//= require <dSS/GetTextHelper>
//= require <dSS/config/Config>
//= require <dSS/util/Util>
Ext.namespace("dSS", "dSS.scene", "dSS.config", "dSS.util");

// parameters:
// maskElement
// dsid
dSS.scene.SceneWindowLight = Ext.extend(Ext.Window, {
    constructor: function(config) {
        this.messagePanel = new Ext.Panel({
            xtype: 'panel',
            ref: 'message',
            id: 'message',
            height: 20,
            columnWidth: 1,
            bodyCfg: {
                cls: 'x-text-align-center x-window-body'
            },
            autoEl: 'span',
            html: _("Move slider to change brightness."),
            bodyBorder: false
        });

        this.dsid = config.dsid;

        this.name = config.name;
        if ((this.name === undefined) || (this.name.length === 0)) {
            this.name = '<i>' + _("no name") + '</i>';
        }

        Ext.apply(this, {
            layout: 'fit',
            width: 370,
            height: 270,
            resizable: false,
            iconCls: 'functionLightIcon',
            title: _("Control light"),
            items: [
            {
                xtype: 'panel',
                bodyCfg: {
                    cls: 'x-window-body'
                },
                bodyBorder: false,
                border: false,
                frame: false,
                hideBorders: true,
                layout: 'table',
                layoutConfig: {
                    columns: 6,
                    tableAttrs: {
                        width: '100%'
                    }
                },
                items: [
                {
                    xtype: 'panel',
                    bodyCfg: {
                        cls: 'x-window-body'
                    },
                    colspan: 6,
                    html: '',
                    height: 50,
                    bodyBorder: false,
                    border: false,
                    frame: false,
                    items: 
                    [
                        {
                            xtype: 'panel',
                            ctCls: 'x-text-align-center x-text-top-margin',
                            html: '<b>'+_("Name") + ": " + '</b>'+ this.name,
                            bodyCfg: {
                                cls: 'x-window-body'
                            },
                            bodyBorder: false,
                            height: 20,
                            width: 370
                            
                        }, 
                        {
                            xtype: 'label',
                            ctCls: 'x-text-align-center x-text-top-margin',
                            html: '<b>' +_("dSID") + ": " + '</b>' + config.dsid
                        }
                    ]
                },
                {
                    xtype: 'panel',
                    html: '',
                    width: 25,
                    rowspan: 7,
                    bodyBorder: false,
                    border: false,
                    frame: false
                },
                {
                    xtype: 'panel',
                    bodyCfg: {
                        cls: 'x-window-body'
                    },
                    colspan: 4,
                    layout: 'table',
                    layoutConfig: {
                        columns: 3,
                        tableAttrs: {
                            width: '100%'
                        }
                    },
                    items: [
                    {
                        xtype: 'panel',
                        bodyCfg: {
                            cls: 'x-window-body'
                        },
                        autoEl: {
                            tag: 'img',
                            align: 'left',
                            src: 'images/lightbulb_off.png'
                        }
                    },
                    this.messagePanel, {
                        xtype: 'panel',
                        bodyCfg: {
                            cls: 'x-window-body'
                        },
                        autoEl: {
                            tag: 'img',
                            align: 'right',
                            src: 'images/lightbulb.png'
                        }
                    }
                    ]
                },
                {
                    xtype: 'panel',
                    html: '',
                    width: 25,
                    rowspan: 7,
                    bodyBorder: false,
                    border: false,
                    frame: false
                },
                {
                    xtype: 'slider',
                    minValue: 0,
                    increment: 1,
                    maxValue: 100,
                    plugins: new Ext.slider.Tip({
                        getText: function(thumb) {
                            return String.format('{0}%', thumb.value);
                        }
                    }),
                    colspan: 4,
                    listeners: {
                        changeComplete: this.handleSliderChanged.createDelegate(this)
                    }
                },
                {
                    xtype: 'button',
                    layout: 'fit',
                    width: 70,
                    text: _("Dim down"),
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.DEC);
                    }
                },
                {
                    xtype: 'panel',
                    colspan: 2,
                    width: 140,
                    html: '',
                    bodyBorder: false,
                    border: false,
                    frame: false
                },

                {
                    xtype: 'button',
                    layout: 'fit',
                    width: 70,
                    text: _("Dim up"),
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.INC);
                    }
                },
                {
                    xtype: 'panel',
                    bodyCfg: {
                        cls: 'x-window-body'
                    },
                    html: '',
                    height: 20,
                    colspan: 4,
                    bodyBorder: false,
                    border: false,
                    frame: false
                },
                {
                    xtype: 'button',
                    layout: 'fit',
                    width: 70,
                    text: _("Scene") + " 1",
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.T0_S1);
                    }
                },
                {
                    xtype: 'button',
                    layout: 'fit',
                    width: 70,
                    text: _("Scene") + " 2",
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.T0_S2);
                    }
                },
                {
                    xtype: 'button',
                    layout: 'fit',
                    width: 70,
                    text: _("Scene") + " 3",
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.T0_S3);
                    }
                },
                {
                    xtype: 'button',
                    layout: 'fit',
                    width: 70,
                    text: _("Scene") + " 4",
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.T0_S4);
                    }
                },
                {
                    xtype: 'panel',
                    bodyCfg: {
                        cls: 'x-window-body'
                    },
                    html: '',
                    height: 5,
                    colspan: 4,
                    bodyBorder: false,
                    border: false,
                    frame: false
                },
                {
                    xtype: 'button',
                    layout: 'fit',
                    width: 70,
                    text: _("Scene") + " 0",
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.T0_S0);
                    }
                },
                {
                    xtype: 'panel',
                    html: '',
                    bodyBorder: false,
                    border: false,
                    frame: false
                },
                {
                    xtype: 'button',
                    layout: 'fit',
                    width: 70,
                    text: _("On"),
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.MAX);
                    }
                },
                {
                    xtype: 'button',
                    width: 70,
                    text: _("Off"),
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.MIN);
                    }
                }]
            }],
            buttons: [
            {
                text: _("Close"),
                scope: this,
                handler: function() {
                    // close ping form dialog
                    this.maskElement.unmask();
                    this.close();
                }
            }]
        });

        dSS.scene.SceneWindowLight.superclass.constructor.apply(this, arguments);

        this.maskElement.mask();

        this.on("beforedestroy", function(component) {
            this.maskElement.unmask();
        },
        this);

    },
    handleSliderChanged: function(slider, newVal, thumb) {
        this.messagePanel.update(_("Brightness set to") + ": " + newVal + "%");
        var value = newVal / 100;
        value = value * 255;
        if (value < 0) {
            value = 0;
        } else if (value > 255) {
            value = 255;
        }

        dSS.util.setValueOnDevice(this.dsid, Math.round(value));
    }
});

