//= require <dSS/GetTextHelper>
//= require <dSS/config/Config>
Ext.namespace("dSS", "dSS.scene", "dSS.config");

// parameters:
// maskElement
// dsid
dSS.scene.SceneWindowShadow = Ext.extend(Ext.Window, {
    constructor: function(config) {

        this.name = config.name;
        if ((this.name === undefined) || (this.name.length === 0)) {
            this.name = '<i>' + _("no name") + '</i>';
        }
    
        Ext.apply(this, {
            layout: 'fit',
            width: 300,
            height: 165,
            resizable: false,
            iconCls: 'functionShadowIcon',
            title: _("Control blinds"),
            items: [
            {
                xtype: 'panel',
                bodyCfg: {
                    cls: 'x-window-body'
                },
                bodyBorder: false,
                border: false,
                frame: false,
                hideBorders: true,
                layout: 'table',
                layoutConfig: {
                    columns: 5,
                    tableAttrs: {
                        width: '100%'
                    }
                },
                items: [
                {
                    xtype: 'panel',
                    bodyCfg: {
                        cls: 'x-window-body'
                    },
                    colspan: 5,
                    html: '',
                    height: 50,
                    bodyBorder: false,
                    border: false,
                    frame: false,
                    items: 
                    [
                        {
                            xtype: 'panel',
                            ctCls: 'x-text-align-center x-text-top-margin',
                            html: '<b>'+_("Name") + ": " + '</b>'+ this.name,
                            bodyCfg: {
                                cls: 'x-window-body'
                            },
                            bodyBorder: false,
                            height: 20,
                            width: 370
                            
                        }, 
                        {
                            xtype: 'label',
                            ctCls: 'x-text-align-center x-text-top-margin',
                            html: '<b>' +_("dSID") + ": " + '</b>' + config.dsid
                        }
                    ]
                },
                {
                    xtype: 'panel',
                    html: '',
                    width: 25,
                    bodyBorder: false,
                    border: false,
                    frame: false
                },

                {
                    xtype: 'button',
                    layout: 'fit',
                    width: 70,
                    text: _("Up"),
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.MAX);
                    }
                },
                {
                    xtype: 'button',
                    width: 70,
                    text: _("Stop"),
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.STOP);
                    }
                },
                {
                    xtype: 'button',
                    width: 70,
                    text: _("Down"),
                    handler: function() {
                        dSS.util.callScene(config.dsid, dSS.config.scenes.MIN);
                    }
                },
                {
                    xtype: 'panel',
                    html: '',
                    width: 25,
                    bodyBorder: false,
                    border: false,
                    frame: false
                }]
            }],
            buttons: [
            {
                text: _("Close"),
                scope: this,
                handler: function() {
                    // close ping form dialog
                    this.maskElement.unmask();
                    this.close();
                }
            }]
        });

        dSS.scene.SceneWindowShadow.superclass.constructor.apply(this, arguments);

        this.maskElement.mask();

        this.on("beforedestroy", function(component) {
            this.maskElement.unmask();
        },
        this);

    }
});

