//= require <dSS/GetTextHelper>
//= require <dSS/util/RadioTextField>
Ext.namespace("dSS", "dSS.util");

dSS.util.DeviceStatisticsForm = Ext.extend(Ext.FormPanel, {
    initComponent: function() {

        Ext.apply(this, {
            frame: true,
            title: _("Device Statistics Settings"),
            labelWidth: 135,
            items: [
            new Ext.grid.GridPanel({
                title: _("Statistics for following devices will be requested") + ":",
                columns: [
                {
                    header: _("dsid"),
                    id: "dsid"
                },
                {
                    header: _("name"),
                    id: "name"
                }],
                autoExpandColumn: "dsid",
                store: this.statisticsStore,
                disableSelection: true,
                frame: false,
                forceFit: true,
                stripeRows: true,
                height: 180,
                autoScroll: true,
                viewConfig: {
                    autoFill: true
                }
            }), new Ext.Panel({
                height: 10
            }), new Ext.form.Radio({
                name: "timefield_rb",
                fieldLabel: _("Request start time"),
                boxLabel: _("Now"),
                checked: true
            }), new dSS.util.RadioTimeField({
                rbname: "timefield_rb",
                name: "time",
                fieldWidth: 140,
                timeFieldWidth: 182,
                format: "H:i",
                allowBlank: false,
                value: this.h_now + this.sep + this.m_now,
                timeFieldEnabled: false
            }), new Ext.form.NumberField({
                width: 200,
                id: "delay",
                allowBlank: false,
                allowNegative: false,
                allowDecimals: false,
                value: "300",
                minValue: "1",
                fieldLabel: _("Delay between repetitions (seconds)")
            }), new Ext.form.NumberField({
                width: 200,
                id: "repeat",
                allowBlank: false,
                allowNegative: false,
                allowDecimals: false,
                value: "0",
                fieldLabel: _("Repeat times")
            })]

        });

        dSS.util.DeviceStatisticsForm.superclass.initComponent.apply(this, arguments);
    }
});

Ext.reg("dssutildevicestatisticsform", dSS.util.DeviceStatisticsForm);

